diff --git a/bgpd/bgpd.c b/bgpd/bgpd.c
index f3cf3f5fb001..7870c9aae54c 100644
--- a/bgpd/bgpd.c
+++ b/bgpd/bgpd.c
@@ -4001,9 +4001,11 @@ void bgp_free(struct bgp *bgp)
 			XFREE(MTYPE_BGP_SRV6_SID,
 			      bgp->vpn_policy[afi]
 				      .tovpn_zebra_vrf_sid_last_sent);
-		if (bgp->vpn_policy[afi].tovpn_sid != NULL)
+		if (bgp->vpn_policy[afi].tovpn_sid != NULL){
+			sid_unregister(bgp, bgp->vpn_policy[afi].tovpn_sid);
 			XFREE(MTYPE_BGP_SRV6_SID,
 			      bgp->vpn_policy[afi].tovpn_sid);
+		}
 	}
 
 	bgp_confederation_id_unset(bgp);
